/************************************************************************
 * ODEVS-C++: Open Source of DEVS in C++                                *
 * Copyright (C) 2005-2006  Moon Ho Hwang <moonho.hwang@gmail.com>      * 
 *                                                                      *
 * This library is free software; you can redistribute it and/or        *
 * modify it under the terms of the GNU Lesser General Public           *
 * License as published by the Free Software Foundation; either         *
 * version 2.1 of the License, or (at your option) any later version.   *
 *                                                                      *
 * This library is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     *
 * Lesser General Public License for more details.                      *
 *                                                                      *
 * You should have received a copy of the GNU Lesser General Public     *
 * License along with this library; if not, write to the Free Software  *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,*  
 * USA.                                                                 * 
*************************************************************************/
#pragma once
#include <PortValue.h>

using namespace ODEVS;

class Client: public Value
{
public:
	const double TimeProcess; 

	double TimeArrival; // 
	double TimeLeavingWaitingLine;//
	double TimeLeavingServer; //

	Client(double pt): TimeProcess(pt), 
				TimeArrival(0), TimeLeavingWaitingLine(0), TimeLeavingServer(0) {}
	Client(const Client& ob): 
			TimeArrival(ob.TimeArrival),
			TimeLeavingWaitingLine(ob.TimeLeavingWaitingLine),
			TimeProcess(ob.TimeProcess),
			TimeLeavingServer(ob.TimeLeavingServer) {} 

	/*virtual*/ Value* Clone() const { return new Client(*this); }
	/*virtual*/ string ToString() const 
	{
		char tmp[100];
		sprintf_s(tmp, "%f, %f, %f, %f",	TimeProcess,
										TimeArrival, 
										TimeLeavingWaitingLine, 
										TimeLeavingServer); 
		return string(tmp);
	}
};

