/************************************************************************
 * ODEVS-C++: Open Source of DEVS in C++                                *
 * Copyright (C) 2005-2006  Moon Ho Hwang <moonho.hwang@gmail.com>      * 
 *                                                                      *
 * This library is free software; you can redistribute it and/or        *
 * modify it under the terms of the GNU Lesser General Public           *
 * License as published by the Free Software Foundation; either         *
 * version 2.1 of the License, or (at your option) any later version.   *
 *                                                                      *
 * This library is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     *
 * Lesser General Public License for more details.                      *
 *                                                                      *
 * You should have received a copy of the GNU Lesser General Public     *
 * License along with this library; if not, write to the Free Software  *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,*  
 * USA.                                                                 * 
*************************************************************************/
#include <Atomic.h>
#include <SRTEngine.h>
#include <iostream>

using namespace std;
using namespace ODEVS;

class SimplestTimer: public Atomic
{
public:
	const OutputPort op;  
	SimplestTimer(const string& name=""): Atomic(name), op("op"){}
    /*virtual*/ void init(){}
	/*virtual*/ void delta_ext(const PortValue& x) {}
	/*virtual*/ void delta_int() {};
	/*virtual*/ PortValue lambda() const{ return PortValue(op); }
	/*virtual*/ Time ta() const { return 3.3; }
	/*virtual*/ string Get_s() const {return "Working"; }
};

void main( void )
{ 
	SimplestTimer* STimer1 = new SimplestTimer("STimer") ; //-- simulation model
	SRTEngine simEngine(*STimer1, NULL, 4);//, NULL, 4); // plug-in sim. model to sim. engine 
    
	simEngine.SetAnimationFlag(false);
	simEngine.SetTimeScale(DBL_MAX); //1000);//DBL_MAX);
	simEngine.Set_dtmode(SRTEngine::P_NONE);	
	
	simEngine.RunConsoleMenu();
	delete STimer1;
}

